#ifndef GAME_H
#define GAME_H
#ifdef __cplusplus
extern "C" {
#endif

#include "libgba/gba.h"

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

enum {
	GAME_EXEC_RESET,
	GAME_EXEC_ANIME,
	GAME_EXEC_PLAY,
	GAME_EXEC_JUDGE,
	GAME_EXEC_OVER,
};

typedef struct {
	u8 act;
	u8 step;

} ST_GAME;



//---------------------------------------------------------------------------
EWRAM_CODE void GameInit(void);

IWRAM_CODE void GameExec(void);
IWRAM_CODE void GameExecReset(void);
IWRAM_CODE void GameExecAnime(void);
IWRAM_CODE void GameExecPlay(void);
IWRAM_CODE void GameExecJudge(void);
IWRAM_CODE void GameExecOver(void);

IWRAM_CODE void GameSetAct(u8 act);


#ifdef __cplusplus
}
#endif
#endif
