#include "bg.h"
#include "../res.h"

//---------------------------------------------------------------------------
ST_BG Bg[BG_MAX_CNT];


//---------------------------------------------------------------------------
EWRAM_CODE void BgInit(void)
{
	_Memset(&Bg, 0x00, sizeof(ST_BG) * BG_MAX_CNT);


	// bg0 None
	// bg1 None
	// bg2 ASCII
	// bg3 wi

	BgSetOpt(2, 0, 30, 0);
	BgSetOpt(3, 1, 31, 0);
	BgSetDatAscii();
	BgSetDatScreen();

//	REG_BG0CNT = (BG_SIZE_3 | BG_16_COLOR | TILE_BASE(Bg[0].tile) | MAP_BASE(Bg[0].map) | 0);
//	REG_BG1CNT = (BG_SIZE_3 | BG_16_COLOR | TILE_BASE(Bg[1].tile) | MAP_BASE(Bg[1].map) | 0);
	REG_BG2CNT = (BG_SIZE_0 | BG_16_COLOR | TILE_BASE(Bg[2].tile) | MAP_BASE(Bg[2].map) | 0);
	REG_BG3CNT = (BG_SIZE_0 | BG_16_COLOR | TILE_BASE(Bg[3].tile) | MAP_BASE(Bg[3].map) | 0);

	REG_DISPCNT = (MODE_0 | BG2_ON | BG3_ON);
}
//---------------------------------------------------------------------------
EWRAM_CODE void BgSetOpt(u32 no, u32 tile, u32 map, u32 pal)
{
	Bg[no].tile = tile;
	Bg[no].map  = map;
	Bg[no].pal  = pal;

	Bg[no].pTile = TILE_BASE_ADR(tile);
	Bg[no].pMap  = MAP_BASE_ADR(map);
	Bg[no].pPal  = BG_PALETTE + (pal * 16);
}
//---------------------------------------------------------------------------
EWRAM_CODE void BgSetDat(u32 no, u16* pTile, u32 tileSize, u16* pPal, u32 palSize)
{
	volatile u32 i;

	for(i=0; i<tileSize/2; i++)
	{
		Bg[no].pTile[i] = pTile[i];
	}

	for(i=0; i<palSize/2; i++)
	{
		Bg[no].pPal[i] = pPal[i];
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void BgSetDatAscii(void)
{
	BgSetDat(2, (u16*)bg_asciiTiles, bg_asciiTilesLen, (u16*)bg_asciiPal, bg_asciiPalLen);
}
//---------------------------------------------------------------------------
EWRAM_CODE void BgSetDatScreen(void)
{
	BgSetDat(3, (u16*)bg_screenTiles, bg_screenTilesLen, (u16*)bg_screenPal, bg_screenPalLen);
}
//---------------------------------------------------------------------------
IWRAM_CODE void BgDrawStr(s32 x, s32 y, char* s)
{
	u16* map = &Bg[2].pMap[x + y * 32];

	while(*s != NULL)
	{
		*map++ = *s++ - ' ';
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void BgDrawStrCls(void)
{
	volatile s32 x, y;

	for(y=0; y<32; y++)
	{
		for(x=0; x<32; x++)
		{
			Bg[2].pMap[x + y * 32] = 0;
		}
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void BgDrawPrintf(s32 x, s32 y, char* format, ...)
{
	char s[100] ALIGN(4);

	char* ap;
	va_start(ap, format);
	_DoSprintf(s, format, ap);
	va_end(ap);

	BgDrawStr(x, y, s);
}
//---------------------------------------------------------------------------
IWRAM_CODE void BgDrawScreen(void)
{
	u32 cnt = 0;
	u32 x, y;

	for(y=0; y<20; y++)
	{
		for(x=0; x<32; x++)
		{
			Bg[3].pMap[x + y * 32] = cnt++;
		}
	}
}
