#ifndef BG_H
#define BG_H
#ifdef __cplusplus
extern "C" {
#endif

#include "../libgba/gba.h"

//---------------------------------------------------------------------------
#define BG_MAX_CNT				4


//---------------------------------------------------------------------------
typedef struct {
	u32  map;
	u16* pMap;

	u32  tile;
	u16* pTile;

	u32  pal;
	u16* pPal;

} ST_BG;


//---------------------------------------------------------------------------
EWRAM_CODE void BgInit(void);

EWRAM_CODE void BgSetOpt(u32 no, u32 tile, u32 map, u32 pal);
EWRAM_CODE void BgSetDat(u32 no, u16* pTile, u32 tileSize, u16* pPal, u32 palSize);
EWRAM_CODE void BgSetDatAscii(void);
EWRAM_CODE void BgSetDatScreen(void);


IWRAM_CODE void BgDrawStr(s32 x, s32 y, char* s);
IWRAM_CODE void BgDrawStrCls(void);
IWRAM_CODE void BgDrawPrintf(s32 x, s32 y, char* format, ...);
IWRAM_CODE void BgDrawScreen(void);


#ifdef __cplusplus
}
#endif
#endif
