#include "rnd.h"
#include "tinymt32.h"


//---------------------------------------------------------------------------
tinymt32_t MathTinyMt;


//---------------------------------------------------------------------------
EWRAM_CODE void RndInit(void)
{
	tinymt32_init(&MathTinyMt, 0xF67C129B);
}
//---------------------------------------------------------------------------
EWRAM_CODE void RndInitSeed(u32 num)
{
	tinymt32_init(&MathTinyMt, num);
}
//---------------------------------------------------------------------------
IWRAM_CODE u32 Rnd32(void)
{
	return tinymt32_generate_uint32(&MathTinyMt);
}
//---------------------------------------------------------------------------
IWRAM_CODE u32 Rnd(u32 num)
{
	s32 n = Mod(Rnd32(), num);

	if(n < 0)
	{
		n *= -1;
	}

	return n;
}
