#ifndef SPR_H
#define SPR_H
#ifdef __cplusplus
extern "C" {
#endif


#include "../libgba/gba.h"

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
EWRAM_CODE void SprInit(void);
EWRAM_CODE void SprInitOam(void);
EWRAM_CODE void SprSetDat(u16* pTile, u32 tileSize, u16* pPal, u32 palSize);
EWRAM_CODE void SprSetDatChr(void);

IWRAM_CODE void SpriteMove(u32 num, s32 x, s32 y);
IWRAM_CODE void SpriteSetSize(u32 num, u32 size, u32 form, u32 col);
IWRAM_CODE void SpriteSetChr(u32 num, u32 chr);
IWRAM_CODE void SpriteSetRotateFlag(u32 num, u32 no, bool isFlag);
IWRAM_CODE void SpriteSetScale(u32 num, u32 xsc, u32 ysc);


IWRAM_CODE void SpriteSetCell(u32 num, u32 chr, s32 fx, s32 fy);
IWRAM_CODE void SpriteSetCell2(u32 num, u32 chr, s32 fx, s32 fy, bool isFlag, u32 sc);
IWRAM_CODE void SpriteScaleCell(u32 num, u32 sc);
IWRAM_CODE void SpriteMoveCell(u32 num, s32 fx, s32 fy);
IWRAM_CODE void SpriteDelCell(u32 total, s32 fx, s32 fy);
IWRAM_CODE u32  SpriteGetCellChrNo(u32 num);


#ifdef __cplusplus
}
#endif
#endif
