#ifndef PANEL_H
#define PANEL_H
#ifdef __cplusplus
extern "C" {
#endif

#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define PANEL_MAX_CX			4
#define PANEL_MAX_CY			4
#define PANEL_MAX_REG_CNT		(PANEL_MAX_CX * PANEL_MAX_CY)

//---------------------------------------------------------------------------

typedef struct {
	s32  regCnt;								// o^
	u32  var[PANEL_MAX_CX][PANEL_MAX_CY];		// l

} ST_PANEL;


//---------------------------------------------------------------------------
EWRAM_CODE void PanelInit(void);

IWRAM_CODE void PanelMakeCell(void);
IWRAM_CODE void PanelMoveCell(s32 sx, s32 sy, s32 x, s32 y, u16 dir);
IWRAM_CODE void PanelMoveCell2(s32 sx, s32 sy, s32 dx, s32 dy, u16 dir);
IWRAM_CODE void PanelMoveUp(void);
IWRAM_CODE void PanelMoveRight(void);
IWRAM_CODE void PanelMoveDown(void);
IWRAM_CODE void PanelMoveLeft(void);

IWRAM_CODE bool PanelIsGameOver(void);
IWRAM_CODE void PanelDebug(void);

#ifdef __cplusplus
}
#endif
#endif
